=== debian/changelog ===
csound (1:6.14.0~dfsg-6) unstable; urgency=high

  * Team upload.
  * debian/control: Replace removed dependency package ttf-dejavu
    with real patch fonts-dejavu. (Closes: #962606)

 -- Boyuan Yang <byang@debian.org>  Thu, 11 Jun 2020 19:55:19 -0400

csound (1:6.14.0~dfsg-5) unstable; urgency=medium

  * Only call dh_doxygen for builds includin arch:all.
    Otherwise we might not have doxygen installed (Closes: #960259)

 -- Felipe Sateler <fsateler@debian.org>  Mon, 11 May 2020 19:49:07 -0400

csound (1:6.14.0~dfsg-4) unstable; urgency=medium

  * Restore patch to ctcsound to import the SOVERSIONed library.
    It was dropped by mistake when updating csound to 6.14
    (Closes: #960128)
  * Don't try to link to system jquery.
    The jquery file provided by doxygen is in fact a collection of
    jquery plus several plugins.
    Therefore, we can't replace it with the system version
  * Use dh_doxygen to remove build-time doxygen output.
    Instead of using our hand-rolled version

 -- Felipe Sateler <fsateler@debian.org>  Sun, 10 May 2020 12:49:31 -0400

csound (1:6.14.0~dfsg-2) unstable; urgency=medium

  * Pick upstream patch fixing duplicate yyin definition.
    Fixes a FTBFS with gcc 10. (Closes: #957111)

 -- Felipe Sateler <fsateler@debian.org>  Sat, 25 Apr 2020 11:56:23 -0400

csound (1:6.14.0~dfsg-1) unstable; urgency=medium

  [ Sebastian Ramacher ]
  * B-D on libstk-dev

  [ Felipe Sateler ]
  * New upstream version 6.14.0~dfsg
    - Drop patches applied upstream and refresh the rest
    - Add new symbols of csound64 library
    - Correctly install ctcsound.
      Upstream installs both in python2 and python3 path. As it is the same
      file, just install them both to the same place
  * Wrap long lines in changelog entries: 1:6.13.0~dfsg-2.
  * Add override for binaries without dependencies
    Small plugins that only call into the host

  [ Laurent Bigonville ]
  * Make the library packages multiarch-installable.
    We need to install the libraries in multiarch-aware directories.
    Additionally we can make csound-data multiarch-foreign

 -- Felipe Sateler <fsateler@debian.org>  Fri, 10 Apr 2020 16:01:10 -0400
