=== debian/tests/control ===
Tests: python3-csound
Depends: python3-csound, python3-all, python3-numpy, python3-matplotlib
